sc::EFCOpt Class Reference

The EFCOpt class implements eigenvector following as described by Baker in J. More...

`#include <efc.h>`

Inheritance diagram for sc::EFCOpt:
[legend]
Collaboration diagram for sc::EFCOpt:
[legend]

## Public Member Functions

| EFCOpt (const Ref< KeyVal > &)
| The KeyVal constructor reads the following keywords: More...
| EFCOpt (StateIn &)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
void | apply_transform (const Ref< NonlinearTransform > &)
void | init ()
| Initialize the optimizer.
int | update ()
| Take a step. More...
Public Member Functions inherited from sc::Optimize
| Optimize (StateIn &)
| Restore the state of a Function object.
| Optimize (const Ref< KeyVal > &)
| The KeyVal constructor reads the following information: More...
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
virtual int | optimize ()
| Do the optimization. More...
void | set_checkpoint ()
| Set up for checkpointing.
void | set_checkpoint_file (const char *)
void | set_function (const Ref< Function > &)
| Set the function to be optimized.
void | set_max_iterations (int)
| Set the iteration limit.
Ref< Function > | function () const
| Returns information about the Function being optimized.
Ref< SCMatrixKit > | matrixkit () const
RefSCDimension | dimension () const
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
virtual void | print (std::ostream &=ExEnv::out0()) const
| Print the object.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Protected Attributes

int | tstate
int | modef
double | maxabs_gradient
double | convergence_
double | accuracy_
RefSymmSCMatrix | hessian_
Ref< HessianUpdate > | update_
RefSCVector | last_mode_
Protected Attributes inherited from sc::Optimize
int | max_iterations_
int | n_iterations_
int | ckpt_
int | print_timings_
double | max_stepsize_
char * | ckpt_file
Ref< Function > | function_
Ref< Convergence > | conv_

## Additional Inherited Members

Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)
Protected Member Functions inherited from sc::SavableState
| SavableState (const SavableState &)
| SavableState (StateIn &)
| Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above. More...

## Detailed Description

The EFCOpt class implements eigenvector following as described by Baker in J.

Comput. Chem., Vol 7, No 4, 385-395, 1986.

## Constructor & Destructor Documentation

sc::EFCOpt::EFCOpt | ( | const Ref< KeyVal > & |  | ) |

The KeyVal constructor reads the following keywords:

`update`

  This gives an HessianUpdate object. The default is to not update the hessian.

`transition_state`

  If this is true than a transition state search will be performed. The default is false.

`mode_following`

  If this is true, then the initial search direction for a transition state search will be choosen to similar to the first coordinate of the Function. The default is false.

`hessian`

  By default, the guess hessian is obtained from the Function object. This keyword specifies an lower triangle array (the second index must be less than or equal to than the first) that replaces the guess hessian. If some of the elements are not given, elements from the guess hessian will be used.

`accuracy`

  The accuracy with which the first gradient will be computed. If this is too large, it may be necessary to evaluate the first gradient point twice. If it is too small, it may take longer to evaluate the first point. The default is 0.0001.

## Member Function Documentation

void sc::EFCOpt::save_data_state | ( | StateOut & |  | ) |

virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

int sc::EFCOpt::update | ( |  | ) |

virtual

Take a step.

Returns 1 if the optimization has converged, otherwise 0.

Implements sc::Optimize.

The documentation for this class was generated from the following file:

- efc.h